
import tempfile
import urllib.request
import logging

logger=logging.getLogger("__main__")


_hdr = {'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) Chrome/23.0.1271.64 Safari/537.11',
       'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
       'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.3',
       'Accept-Encoding': 'none',
       'Accept-Language': 'en-US,en;q=0.8',
       'Connection': 'keep-alive'}


def downloadUrlToFile(urlLink,filePath=None,headers=_hdr):
    """
    :param url: Url to be downloaded. Will usually be a linke to a json, csv file.
    :param filePath: Path to write to.
    :return:
    """
    try:
        filePath = filePath or tempfile.mktemp()

        onlineFile=urllib.request.Request(urlLink,headers=headers)
        onlineFileData=urllib.request.urlopen(onlineFile).read()

        with open(filePath,"wb") as csvWrite:
            csvWrite.write(onlineFileData)
        logger.debug("Downloaded %s to %s"%(urlLink,filePath))
    except:
        logger.error("Could not download %s"%urlLink)
        raise Exception

    return filePath